﻿
using System;
using System.Linq;
using Wisej.Web;

namespace Wisej.StockQuotesSample
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();

			this.Disposed += Page1_Disposed;
		}

		private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
		{
			this.button1.Enabled = this.listBox1.SelectedIndex > -1;
		}

		private void Page1_Load(object sender, EventArgs e)
		{
			this.listBox1.Items.AddRange(StockList.List);

			QuoteServer.QuotesUpdated += QuoteServer_QuotesUpdated;
		}

		private void Page1_Disposed(object sender, EventArgs e)
		{
			QuoteServer.QuotesUpdated -= QuoteServer_QuotesUpdated;
		}

		private void QuoteServer_QuotesUpdated(object sender, QuotesUpdatedEventargs e)
		{
			Application.Update(this, () =>
			{
				foreach (StockQuote item in this.panel1.Controls)
				{
					var index = Array.IndexOf(e.Stocks, item.Stock);
					if (index > -1)
					{
						item.Quote = e.Quotes[index];

						// animate when the value changes.
						this.animation1.Run(item);
					}
				}

				this.label4.Text = DateTime.Now.ToString();
			});
		}

		private void button1_Click(object sender, EventArgs e)
		{
			var stock = (string)this.listBox1.SelectedItem;
			this.listBox1.Items.Remove(stock);

			var item = new StockQuote()
			{
				Quote = 0,
				Stock = stock,
				Dock = DockStyle.Top
			};
			this.panel1.Controls.Add(item);

			item.Remove += Item_Remove;
			this.animation1.GetAnimation(item).Name = "blink";
		}

		private void Item_Remove(object sender, EventArgs e)
		{
			var item = (StockQuote)sender;
			this.panel1.Controls.Remove(item);
			this.listBox1.Items.Add(item.Stock);
			item.Dispose();
		}
	}
}
